%define with_xine 0

%define gstreamer_version 0.10.1
%define gstreamer_plugins_base_version 0.10.17.2-4
%define gstreamer_plugins_good_version 0.10.0
%define gstreamer_plugins_flumpegdemux_version 0.10.15
%define gtk2_version 2.12.1
%define xine_version 1.1.7

Summary: Movie player for GNOME
Name: totem
Version: 2.26.1
Release: 2.1.moblin2
License: GPLv2+ with exceptions
Group: Applications/Multimedia
URL: http://projects.gnome.org/totem/
Source0: http://download.gnome.org/sources/totem/2.26/totem-%{version}.tar.bz2
Source1: totem-bin-backend-ondemand.sh
Patch0: totem-remove-gconfelement-queries.patch
Patch1: totem-fix-omf-install-breakage.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n) 

Requires(pre): GConf2 >= 2.14
Requires(preun): GConf2 >= 2.14
Requires(post): GConf2 >= 2.14
Requires(post): desktop-file-utils
Requires(post): scrollkeeper
Requires(postun): desktop-file-utils
Requires(postun): scrollkeeper

Requires: iso-codes
Requires: gnome-themes
Requires: gtk2 >= %gtk2_version
# FIXME?
#Requires: %{name}-backend = %{version}-%{release}
Requires: %{name}-gstreamer

BuildRequires: gcc-c++, pkgconfig, gettext
BuildRequires: perl(XML::Parser) intltool
BuildRequires: iso-codes-devel
BuildRequires: gnome-icon-theme
BuildRequires: libXtst-devel
BuildRequires: libXxf86vm-devel
BuildRequires: libXt-devel
BuildRequires: gnome-doc-utils
BuildRequires: python-devel gnome-python2-devel pygtk2-devel
BuildRequires: totem-pl-parser-devel

# Screensaver, mozilla and mmkeys plugin
BuildRequires: dbus-devel


# For plugins
#BuildRequires: tracker-devel
#BuildRequires: libepc-devel


%description
Totem is simple movie player for the GNOME desktop. It features a
simple playlist, a full-screen mode, seek and volume controls, as well as
a pretty complete keyboard navigation.

Totem is extensible through a plugin system.

%package gstreamer
Summary: Gstreamer backend for Totem
Group: Applications/Multimedia
Provides: %{name}-backend = %{version}-%{release}
Obsoletes: totem-gstreamer < 2.23.0
Requires: %{name} = %{version}
Requires: gstreamer >= %gstreamer_version
Requires: gst-plugins-base >= %gstreamer_plugins_base_version
Requires: gst-plugins-good >= %gstreamer_plugins_good_version
Requires: gvfs-fuse
BuildRequires: gstreamer-devel >= %gstreamer_version
BuildRequires: gst-plugins-base-devel >= %gstreamer_plugins_base_version
BuildRequires: gst-plugins-good >= %gstreamer_plugins_good_version
BuildRequires: liboil >= 0.3.13-5

%description gstreamer
This package provides the gstreamer backend for the Totem media player.

%if %{with_xine}
%package xine
Summary: Xine backend for Totem
Group: Applications/Multimedia
Provides: %{name}-backend = %{version}-%{release}
Requires: %{name} = %{version}
Requires: xine-lib >= %{xine_version}
BuildRequires: xine-lib-devel >= %{xine_version}

%description xine
This package provides the xine backend for the Totem media player.
%endif

%package mozplugin
Summary: Mozilla plugin for Totem
Group: Applications/Internet

%description mozplugin
Totem is simple movie player for the GNOME desktop. 
The mozilla plugin for Totem allows it to be embedded into a web browser. 

%package youtube
Summary: YouTube plugin for Totem
Group: Applications/Multimedia
Requires: python-gdata
Requires: %{name} = %{version}-%{release}

%description youtube
This package provides a plugin to allow browsing YouTube videos in Totem, 
and watching them.

To play back the videos however, you will need codecs that are not
available in the Fedora repositories.

%package jamendo
Summary: Jamendo plugin for Totem
Group: Applications/Multimedia
Requires: python-gdata
Requires: %{name} = %{version}-%{release}

%description jamendo
This package provides a plugin to allow browsing the Jamendo music store
in Totem, and listening to them.

%package upnp
Summary: UPNP/DLNA plugin for Totem
Group: Applications/Multimedia
Requires: python-Coherence
Requires: %{name} = %{version}-%{release}

%description upnp
This package provides a plugin to allow browsing UPNP/DLNA shares,
and watching videos from those.

%package devel
Summary: Plugin writer's documentation for %{package}
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
The %{name}-devel package contains API documentation for
developing developing plugins for %{name}.


%prep
%setup -q -c
# Whatever needs to be changed in both copies do here
## remember to update me when changing %doc
for i in AUTHORS COPYING NEWS README TODO;do
  cp totem-%{version}/$i .
done

cd totem-%{version}
%patch0 -p1
%patch1 -p1
cd ..

# duplicate sources
cp -a totem-%{version} xine
mv totem-%{version} gstreamer

%build

pushd gstreamer
# try to work around a problem where gst-inspect does 
# not find playbin the first time around
DBUS_FATAL_WARNINGS=0 /usr/bin/gst-inspect-0.10 --print-all > /dev/null
export MOZILLA_PLUGINDIR=%{_libdir}/mozilla/plugins
%configure \
  --enable-gstreamer \
  --enable-mozilla \
  --disable-scrollkeeper \
  --disable-nvtv

make %{?_smp_mflags}
popd

%if %{with_xine}
# Build the xine-lib backend with minimum dependencies
pushd xine
export MOZILLA_PLUGINDIR=%{_libdir}/mozilla/plugins
%configure \
  --enable-xine \
  --disable-gstreamer \
  --disable-mozilla   \
  --disable-nautilus  \
  --disable-scrollkeeper  \
  --disable-nvtv

cd src/backend/
make %{?_smp_mflags}
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT
export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1

# GSTREAMER INSTALL
pushd gstreamer/
make install DESTDIR=$RPM_BUILD_ROOT
# move the backend library away
mv $RPM_BUILD_ROOT/%{_libdir}/libbaconvideowidget.so.0.0.0 $RPM_BUILD_ROOT/%{_libdir}/libbaconvideowidget-gstreamer.so.0.0.0
# language hack
%find_lang %{name} --with-gnome
mv %{name}.lang ../
popd

%if %{with_xine}
# XINE INSTALL
pushd xine/src/backend
make install DESTDIR=$RPM_BUILD_ROOT
mv $RPM_BUILD_ROOT/%{_libdir}/libbaconvideowidget.so.0.0.0 $RPM_BUILD_ROOT/%{_libdir}/libbaconvideowidget-xine.so.0.0.0
popd
%endif

rm -rf $RPM_BUILD_ROOT%{_libdir}/totem/plugins/*/*.{a,la} \
 $RPM_BUILD_ROOT%{_libdir}/mozilla/plugins/*.{a,la} \
 $RPM_BUILD_ROOT%{_libdir}/nautilus/extensions-2.0/*.{a,la} \
 $RPM_BUILD_ROOT%{_libdir}/libbaconvideowidget*.{a,la} \
 $RPM_BUILD_ROOT%{_libdir}/libbaconvideowidget.so \
 $RPM_BUILD_ROOT%{_libdir}/totem/plugins/bemused/

%find_lang %{name} --with-gnome

install -m755 %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}-backend

# save space by linking identical images in translated docs
helpdir=$RPM_BUILD_ROOT%{_datadir}/gnome/help/%{name}
for f in $helpdir/C/figures/*.png; do
  b="$(basename $f)"
  for d in $helpdir/*; do
    if [ -d "$d" -a "$d" != "$helpdir/C" ]; then
      g="$d/figures/$b"
      if [ -f "$g" ]; then
        if cmp -s $f $g; then
          rm "$g"; ln -s "../../C/figures/$b" "$g"
        fi
      fi
    fi
  done
done


%clean
rm -rf $RPM_BUILD_ROOT

%post
scrollkeeper-update -q
update-desktop-database -q
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule \
        %{_sysconfdir}/gconf/schemas/totem.schemas \
        %{_sysconfdir}/gconf/schemas/totem-handlers.schemas \
        %{_sysconfdir}/gconf/schemas/totem-video-thumbnail.schemas \
 >& /dev/null || :
touch %{_datadir}/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
  /usr/bin/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor
fi

%post gstreamer
/usr/sbin/alternatives --install %{_libdir}/libbaconvideowidget.so.0.0.0 totem-backend %{_libdir}/libbaconvideowidget-gstreamer.so.0.0.0 2
/sbin/ldconfig

%if %{with_xine}
%post xine
/usr/sbin/alternatives --install %{_libdir}/libbaconvideowidget.so.0.0.0 totem-backend %{_libdir}/libbaconvideowidget-xine.so.0.0.0 1
/sbin/ldconfig
%endif

%pre
if [ "$1" -gt 1 ]; then
    export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
    gconftool-2 --makefile-uninstall-rule \
        %{_sysconfdir}/gconf/schemas/totem.schemas \
        %{_sysconfdir}/gconf/schemas/totem-handlers.schemas \
        %{_sysconfdir}/gconf/schemas/totem-video-thumbnail.schemas \
 >& /dev/null || :
fi

%preun
if [ "$1" -eq 0 ]; then
    export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
    gconftool-2 --makefile-uninstall-rule \
        %{_sysconfdir}/gconf/schemas/totem.schemas \
        %{_sysconfdir}/gconf/schemas/totem-handlers.schemas \
        %{_sysconfdir}/gconf/schemas/totem-video-thumbnail.schemas \
 >& /dev/null || :
fi

%postun
scrollkeeper-update -q
update-desktop-database -q
touch %{_datadir}/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
  /usr/bin/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor
fi

%postun gstreamer
if [ "$1" -eq 0 ]; then
  /usr/sbin/alternatives --remove totem-backend %{_libdir}/libbaconvideowidget-gstreamer.so.0.0.0
fi
/sbin/ldconfig

%if %{with_xine}
%postun xine
if [ "$1" -eq 0 ]; then
  /usr/sbin/alternatives --remove totem-backend %{_libdir}/libbaconvideowidget-xine.so.0.0.0
fi
/sbin/ldconfig
%endif

%files -f %{name}.lang
%defattr(-,root,root,-)
%doc AUTHORS COPYING NEWS README TODO
%config %{_sysconfdir}/gconf/schemas/totem.schemas
%config %{_sysconfdir}/gconf/schemas/totem-handlers.schemas
%config %{_sysconfdir}/gconf/schemas/totem-video-thumbnail.schemas
%{_bindir}/%{name}
%{_bindir}/%{name}-backend
%{_bindir}/%{name}-video-thumbnailer
%{_bindir}/%{name}-video-indexer
%{_bindir}/%{name}-audio-preview
%{_datadir}/applications/%{name}.desktop
%{_datadir}/%{name}/
%dir %{_libexecdir}/totem
%{_libexecdir}/totem/totem-bugreport.py
%exclude %{_libexecdir}/totem/totem-bugreport.py[co]
%{_libdir}/libbaconvideowidget.so*
%dir %{_libdir}/totem/plugins
%{_libdir}/totem/plugins/brasero-disc-recorder
%{_libdir}/totem/plugins/gromit
%{_libdir}/totem/plugins/ontop
%{_libdir}/totem/plugins/screensaver
%{_libdir}/totem/plugins/skipto
%{_libdir}/totem/plugins/properties
%{_libdir}/totem/plugins/media-player-keys
%{_libdir}/totem/plugins/totem
%{_libdir}/totem/plugins/thumbnail
%{_libdir}/totem/plugins/opensubtitles
%{_libdir}/totem/plugins/pythonconsole
%{_libdir}/totem/plugins/screenshot
#%{_libdir}/totem/plugins/bemused
%{_datadir}/icons/hicolor/*/apps/totem.png
%{_datadir}/icons/hicolor/*/devices/totem-tv.png
%{_datadir}/icons/hicolor/scalable/apps/totem.svg
%{_datadir}/icons/hicolor/scalable/devices/totem-tv.svg
%{_mandir}/man1/%{name}.1*
%{_mandir}/man1/totem-video-thumbnailer.1.gz


%files youtube
%defattr(-, root, root)
%{_libdir}/totem/plugins/youtube

%files jamendo
%defattr(-, root, root)
%{_libdir}/totem/plugins/jamendo

%files upnp
%defattr(-, root, root)
%{_libdir}/totem/plugins/coherence_upnp

%files devel
%defattr(-, root, root)
%{_datadir}/gtk-doc/html/totem

#%files tracker
#%defattr(-, root, root)
#%{_libdir}/totem/plugins/tracker

%files mozplugin
%defattr(-, root, root)
%{_libdir}/mozilla/plugins/*
%{_libexecdir}/totem-plugin-viewer

%files gstreamer
%{_libdir}/libbaconvideowidget-gstreamer.so.0.0.0

%if %{with_xine}
%files xine
%{_libdir}/libbaconvideowidget-xine.so.0.0.0
%endif

%changelog
* Thu Apr 16 2009 Vivian Zhang <vivian.zhang@intel.com> 2.26.0
- Update to version 2.26.1
- Add Requires: gvfs-fuse
* Wed Mar 18 2009 Vivian Zhang <vivian.zhang@intel.com> 2.26.0
- Update to version 2.26.0
* Tue Mar 10 2009 Vivian Zhang <vivian.zhang@intel.com> 2.25.92
- Update to version 2.25.92
- Fix source url
* Sun Feb  1 2009 Arjan van de Ven <arjan@linux.intel.com> 2.25.3
- drop fuse requirements
* Wed Jan 21 2009 Anas Nashif <anas.nashif@intel.com> 2.25.3
- Initial import into Moblin
